<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE module PUBLIC "-//Checkstyle//DTD Checkstyle Configuration 1.3//EN" "https://checkstyle.org/dtds/configuration_1_3.dtd">

<!--
    This configuration file was written by the eclipse-cs plugin configuration editor
-->
<!--
    Checkstyle-Configuration: Eclipse LSAT
    Description: 
Eclipse LSAT Checkstyle

Copyright (c) 2021 Contributors to the Eclipse Foundation

This program and the accompanying materials are made
available under the terms of the Eclipse Public License 2.0
which is available at https://www.eclipse.org/legal/epl-2.0/

SPDX-License-Identifier: EPL-2.0
-->
<module name="Checker">
  <property name="severity" value="warning"/>
  <module name="TreeWalker">
    <module name="AnnotationUseStyle"/>
    <module name="MissingOverride"/>
    <module name="AnnotationLocation">
      <property name="allowSamelineSingleParameterlessAnnotation" value="false"/>
    </module>
    <module name="AtclauseOrder"/>
    <module name="JavadocStyle">
      <property name="severity" value="ignore"/>
      <property name="scope" value="anoninner"/>
      <property name="endOfSentenceFormat" value="([.?!:][ \t\n\r\f&lt;])|([.?!:]$)|(\{@inheritDoc\})"/>
      <property name="checkEmptyJavadoc" value="true"/>
      <message key="javadoc.noperiod" value="First sentence should end with a period, question mark, exclamation mark, colon, or '{@inheritDoc}'."/>
      <metadata name="net.sf.eclipsecs.core.lastEnabledSeverity" value="inherit"/>
    </module>
    <module name="NonEmptyAtclauseDescription">
      <property name="severity" value="ignore"/>
      <metadata name="net.sf.eclipsecs.core.lastEnabledSeverity" value="inherit"/>
    </module>
    <module name="JavadocTagContinuationIndentation">
      <message key="tag.continuation.indent" value="Line continuation has incorrect indentation level, expected level should be {0} spaces more than previous line."/>
    </module>
    <module name="JavadocParagraph">
      <message key="javadoc.paragraph.line.before" value="&lt;p&gt; tag should be preceded an with empty line."/>
    </module>
    <module name="ConstantName">
      <message key="name.invalidPattern" value="Constant name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="LocalVariableName">
      <property name="format" value="^_?[a-z]\w*$"/>
      <message key="name.invalidPattern" value="Local variable name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="LocalFinalVariableName">
      <property name="format" value="^(([A-Z][A-Z0-9]*(_[A-Z0-9]+)*)|([a-z][a-z0-9]*(_[a-z0-9]+)*)|(_?[a-z][a-zA-Z0-9]*_?))$"/>
      <message key="name.invalidPattern" value="Local final variable name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="MemberName">
      <property name="format" value="^[a-z]\w*$"/>
      <message key="name.invalidPattern" value="Member name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="MethodName">
      <property name="format" value="^((_?[a-z]\w*)|[A-Z]+)$"/>
      <message key="name.invalidPattern" value="Method name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="PackageName">
      <property name="format" value="^[a-z]+(\.[a-z](_?[a-z0-9]+)*)*$"/>
      <message key="name.invalidPattern" value="Package name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="ParameterName">
      <property name="format" value="^(([a-z][a-z0-9]*(_[a-z0-9]+)*)|(_?[a-z][a-zA-Z0-9]*_?))$"/>
      <property name="accessModifiers" value="private"/>
    </module>
    <module name="StaticVariableName">
      <message key="name.invalidPattern" value="Static variable name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="TypeName">
      <metadata name="net.sf.eclipsecs.core.comment" value="General type name"/>
      <message key="name.invalidPattern" value="Type name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="ClassTypeParameterName">
      <property name="format" value="^[A-Z][a-zA-Z0-9]*$"/>
      <message key="name.invalidPattern" value="Class type parameter name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="MethodTypeParameterName">
      <property name="format" value="^[A-Z][a-zA-Z0-9]*$"/>
      <message key="name.invalidPattern" value="Method type parameter name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="InterfaceTypeParameterName">
      <property name="format" value="^[A-Z][a-zA-Z0-9]*$"/>
      <message key="name.invalidPattern" value="Interface type parameter name ''{0}'' must match pattern ''{1}''."/>
    </module>
    <module name="AvoidStarImport"/>
    <module name="IllegalImport"/>
    <module name="RedundantImport"/>
    <module name="UnusedImports"/>
    <module name="GenericWhitespace">
      <message key="ws.notPreceded" value="''{0}'' is not preceded with whitespace. (generics whitespace check)"/>
      <message key="ws.followed" value="''{0}'' is followed by whitespace. (generics whitespace check)"/>
      <message key="ws.illegalFollow" value="''{0}'' is followed by an illegal character. (generics whitespace check)"/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace. (generics whitespace check)"/>
    </module>
    <module name="EmptyForInitializerPad">
      <message key="ws.notPreceded" value="''{0}'' is not preceded with whitespace, for empty 'for' initializer."/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace, for empty 'for' initializer."/>
    </module>
    <module name="EmptyForIteratorPad">
      <message key="ws.notFollowed" value="''{0}'' is not followed by whitespace, for empty 'for' iterator."/>
      <message key="ws.followed" value="''{0}'' is followed by whitespace, for empty 'for' iterator."/>
    </module>
    <module name="NoWhitespaceAfter">
      <metadata name="net.sf.eclipsecs.core.comment" value="no line breaks"/>
      <property name="allowLineBreaks" value="false"/>
      <property name="tokens" value="AT,INC,DEC,UNARY_MINUS,UNARY_PLUS,BNOT,LNOT,DOT"/>
      <message key="ws.followed" value="''{0}'' is followed by whitespace. (no whitespace after check)"/>
    </module>
    <module name="NoWhitespaceBefore">
      <metadata name="net.sf.eclipsecs.core.comment" value="no line breaks"/>
      <property name="tokens" value="POST_DEC,POST_INC"/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace. (no whitespace before check)"/>
    </module>
    <module name="MethodParamPad">
      <message key="line.previous" value="''{0}'' should be on the previous line. (method parameter padding check)"/>
      <message key="ws.notPreceded" value="''{0}'' is not preceded with whitespace. (method parameter padding check)"/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace. (method parameter padding check)"/>
    </module>
    <module name="TypecastParenPad">
      <message key="ws.notPreceded" value="''{0}'' is not preceded with whitespace. (typecast parenthesis padding check)"/>
      <message key="ws.notFollowed" value="''{0}'' is not followed by whitespace. (typecast parenthesis padding check)"/>
      <message key="ws.followed" value="''{0}'' is followed by whitespace. (typecast parenthesis padding check)"/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace. (typecast parenthesis padding check)"/>
    </module>
    <module name="WhitespaceAfter">
      <property name="tokens" value="COMMA,SEMI"/>
      <message key="ws.notFollowed" value="''{0}'' is not followed by whitespace. (whitespace after check)"/>
    </module>
    <module name="WhitespaceAround">
      <property name="tokens" value="ASSIGN,BAND,BAND_ASSIGN,BOR,BOR_ASSIGN,BSR,BSR_ASSIGN,BXOR,BXOR_ASSIGN,COLON,DIV,DIV_ASSIGN,DO_WHILE,EQUAL,GE,GT,LAND,LCURLY,LE,LITERAL_ASSERT,LITERAL_CATCH,LITERAL_DO,LITERAL_ELSE,LITERAL_FINALLY,LITERAL_FOR,LITERAL_IF,LITERAL_RETURN,LITERAL_SYNCHRONIZED,LITERAL_TRY,LITERAL_WHILE,LOR,LT,MINUS,MINUS_ASSIGN,MOD,MOD_ASSIGN,NOT_EQUAL,PLUS,PLUS_ASSIGN,QUESTION,RCURLY,SL,SLIST,SL_ASSIGN,SR,SR_ASSIGN,STAR,STAR_ASSIGN,TYPE_EXTENSION_AND"/>
      <message key="ws.notPreceded" value="''{0}'' is not preceded with whitespace. (whitespace around check)"/>
      <message key="ws.notFollowed" value="''{0}'' is not followed by whitespace. (whitespace around check)"/>
    </module>
    <module name="EmptyLineSeparator">
      <property name="allowNoEmptyLineBetweenFields" value="true"/>
      <property name="tokens" value="IMPORT,STATIC_IMPORT,CLASS_DEF,INTERFACE_DEF,ENUM_DEF,STATIC_INIT,INSTANCE_INIT,METHOD_DEF,CTOR_DEF,VARIABLE_DEF,RECORD_DEF,COMPACT_CTOR_DEF"/>
    </module>
    <module name="SeparatorWrap">
      <metadata name="net.sf.eclipsecs.core.comment" value="separator at end of the line"/>
      <property name="tokens" value="COMMA,SEMI,ARRAY_DECLARATOR,RBRACK"/>
      <message key="line.previous" value="''{0}'' separator should be on the previous line."/>
      <message key="line.new" value="''{0}'' separator should be on a new line."/>
    </module>
    <module name="SeparatorWrap">
      <metadata name="net.sf.eclipsecs.core.comment" value="separator on new line"/>
      <property name="option" value="nl"/>
      <property name="tokens" value="DOT"/>
      <message key="line.previous" value="''{0}'' separator should be on the previous line."/>
      <message key="line.new" value="''{0}'' separator should be on a new line."/>
    </module>
    <module name="NoWhitespaceBefore">
      <metadata name="net.sf.eclipsecs.core.comment" value="allow line breaks"/>
      <property name="allowLineBreaks" value="true"/>
      <property name="tokens" value="SEMI,DOT"/>
      <message key="ws.preceded" value="''{0}'' is preceded with whitespace. (no whitespace before check)"/>
    </module>
    <module name="NoWhitespaceAfter">
      <metadata name="net.sf.eclipsecs.core.comment" value="allow line breaks"/>
      <property name="tokens" value="TYPECAST"/>
      <message key="ws.followed" value="''{0}'' is followed by whitespace. (no whitespace after check)"/>
    </module>
    <module name="ModifierOrder"/>
    <module name="NeedBraces">
      <property name="tokens" value="LITERAL_DO,LITERAL_FOR,LITERAL_WHILE"/>
    </module>
    <module name="LeftCurly">
      <property name="option" value="nlow"/>
      <message key="line.previous" value="Block start curly brace ''{0}'' should be on the previous line."/>
      <message key="line.new" value="Block start curly brace ''{0}'' should be on a new line."/>
    </module>
    <module name="RightCurly">
      <metadata name="net.sf.eclipsecs.core.comment" value="same line"/>
      <message key="line.alone" value="Block end curly brace ''{0}'' should be alone on a line."/>
      <message key="line.new" value="Block end curly brace ''{0}'' should be on a new line."/>
      <message key="line.same" value="Block end curly brace ''{0}'' should be on the same line."/>
    </module>
    <module name="RightCurly">
      <metadata name="net.sf.eclipsecs.core.comment" value="alone on line"/>
      <property name="option" value="alone_or_singleline"/>
      <property name="tokens" value="CLASS_DEF,METHOD_DEF,CTOR_DEF,LITERAL_FOR,LITERAL_WHILE,STATIC_INIT,INSTANCE_INIT,ENUM_DEF,INTERFACE_DEF"/>
      <message key="line.alone" value="Block end curly brace ''{0}'' should be alone on a line."/>
      <message key="line.new" value="Block end curly brace ''{0}'' should be on a new line."/>
      <message key="line.same" value="Block end curly brace ''{0}'' should be on the same line."/>
    </module>
    <module name="CovariantEquals">
      <message key="covariant.equals" value="Covariant equals without overriding equals(java.lang.Object)."/>
    </module>
    <module name="DefaultComesLast"/>
    <module name="InnerAssignment">
      <metadata name="net.sf.eclipsecs.core.comment" value="Detects more than Eclipse JDT check."/>
      <message key="assignment.inner.avoid" value="Assignment in expression (inner assignment) should be avoided."/>
    </module>
    <module name="ModifiedControlVariable">
      <property name="skipEnhancedForLoopVariable" value="true"/>
    </module>
    <module name="NoClone"/>
    <module name="NoFinalizer"/>
    <module name="PackageDeclaration">
      <message key="missing.package.declaration" value="Avoid the default package."/>
    </module>
    <module name="SimplifyBooleanExpression">
      <message key="simplify.expression" value="Boolean expression can be simplified."/>
    </module>
    <module name="StringLiteralEquality"/>
    <module name="SuperClone"/>
    <module name="SuperFinalize"/>
    <module name="HideUtilityClassConstructor"/>
    <module name="MutableException"/>
    <module name="OneTopLevelClass"/>
    <module name="ArrayTypeStyle">
      <message key="array.type.style" value="Use Java style for arrays (brackets with the type) not C style (brackets with the name)."/>
    </module>
    <module name="UpperEll">
      <message key="upperEll" value="Should use uppercase ''L'' for long numbers, not lowercase &quot;l&quot;."/>
    </module>
    <module name="RegexpSinglelineJava">
      <metadata name="net.sf.eclipsecs.core.comment" value="Wrong indentation for lines starting with '{' or '}'."/>
      <property name="format" value="^(\s{4})*(\s|\s\s|\s\s\s)[{}]$"/>
      <property name="message" value="Wrong indentation. Must be a multiple of 4 spaces."/>
    </module>
    <module name="SuppressWithNearbyCommentFilter">
      <metadata name="net.sf.eclipsecs.core.comment" value="'ignore checkstyle' comment prefix on same line"/>
      <property name="commentFormat" value="ignore checkstyle (\w+)"/>
      <property name="checkFormat" value="$1"/>
    </module>
    <module name="ImportOrder">
      <property name="option" value="top"/>
      <property name="groups" value="/^java\./,javax,org,com"/>
      <property name="separated" value="true"/>
      <property name="separatedStaticGroups" value="true"/>
      <property name="sortStaticImportsAlphabetically" value="true"/>
      <property name="useContainerOrderingForStatic" value="true"/>
    </module>
    <module name="TypeName">
      <metadata name="net.sf.eclipsecs.core.comment" value="Test classes must end with 'Test', not 'Tests' to be picked up by Tycho"/>
      <property name="format" value="^.*(?&lt;!Tests)$"/>
    </module>
    <module name="SingleSpaceSeparator"/>
    <module name="UnnecessarySemicolonAfterOuterTypeDeclaration"/>
    <module name="UnnecessarySemicolonAfterTypeMemberDeclaration"/>
    <module name="AvoidDoubleBraceInitialization"/>
    <module name="JavadocMissingWhitespaceAfterAsterisk">
      <property name="violateExecutionOnNonTightHtml" value="true"/>
    </module>
    <module name="NoCodeInFile"/>
    <module name="RequireEmptyLineBeforeBlockTagGroup">
      <property name="violateExecutionOnNonTightHtml" value="true"/>
    </module>
    <module name="RegexpSinglelineJava">
      <metadata name="net.sf.eclipsecs.core.comment" value="JavaDoc @-tag description should not start with a lower-case letter."/>
      <property name="severity" value="ignore"/>
      <property name="format" value="(@param \w+|@return) [a-z]"/>
      <property name="message" value="JavaDoc @-tag description should not start with a lower-case letter."/>
      <metadata name="net.sf.eclipsecs.core.lastEnabledSeverity" value="inherit"/>
    </module>
  </module>
  <module name="RegexpSingleline">
    <metadata name="net.sf.eclipsecs.core.comment" value="XXX -- Could be improved if Checkstyle issue #976 is fixed."/>
    <property name="format" value="XXX"/>
    <property name="message" value="Found XXX."/>
    <property name="fileExtensions" value="java,xml,MF,properties,txt"/>
  </module>
  <module name="FileTabCharacter">
    <property name="fileExtensions" value="java,xml,MF,properties,txt"/>
  </module>
  <module name="RegexpMultiline">
    <metadata name="net.sf.eclipsecs.core.comment" value="Multiple consecutive empty lines"/>
    <property name="format" value="(\r?\n){3}"/>
    <property name="message" value="Multiple consecutive empty lines found."/>
    <property name="fileExtensions" value="java,xml,MF,properties,txt"/>
  </module>
  <module name="RegexpSingleline">
    <metadata name="net.sf.eclipsecs.core.comment" value="Trailing whitespace"/>
    <property name="format" value="^.*\s$"/>
    <property name="message" value="Trailing whitespace found."/>
    <property name="fileExtensions" value="java,xml,MF,properties,txt"/>
  </module>
  <module name="NewlineAtEndOfFile">
    <property name="fileExtensions" value="java,xml,MF,properties,txt"/>
  </module>
  <module name="UniqueProperties"/>
</module>
